<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Tim Lochmueller, Sareen Millet, Dr. Ronald Steiner
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');

/**
 * Extends tslib_cObj to change the path for the images
 *
 */
class ux_tslib_cObj extends tslib_cObj {
	
	var $fl_conf = array();     // the configuration array for fl_realurl_image
	var $imgTexts = array();  	// Possible Text that can serve as a basis for file name or alternative text generation

/**
	 * Rendering the cObject, IMG_RESOURCE
	 *
	 * @param	array		Array of TypoScript properties
	 * @return	string		Output
	 * @link http://typo3.org/doc.0.html?&tx_extrepmgm_pi1[extUid]=270&tx_extrepmgm_pi1[tocEl]=354&cHash=46f9299706
	 * @see getImgResource()
	 */
	function IMG_RESOURCE($conf)	{
		###################################
		## Here begins RealUrl_image ######
		###################################
		// get the image info
		$info = $this->getImgResource($conf['file'],$conf['file.']);
		$GLOBALS['TSFE']->lastImgResourceInfo = $info;
		// initialice class variables
		$this->fl_realurl_image_init($conf);
		// get the original file path
		$org_file_path = htmlspecialchars(trim(t3lib_div::rawUrlEncodeFP($info[3])));
		// generate the file path
		if ($conf['imageLinkName.']['enable']) {
		    $file_name = $this->fl_realurl_image_generateFilePath($org_file_path,$info,$conf);
		}
		else {
		    $file_name = $org_file_path;
		}		
		$theValue = htmlspecialchars($GLOBALS['TSFE']->absRefPrefix).$file_name;
		// stdWrap and return	
		return $this->stdWrap($theValue,$conf['stdWrap.']);
		##################################
        ### Here ends RealURL_Image ######
        ##################################
        /*	
		$GLOBALS['TSFE']->lastImgResourceInfo = $this->getImgResource($conf['file'],$conf['file.']);
		return $this->stdWrap($GLOBALS['TSFE']->lastImgResourceInfo[3],$conf['stdWrap.']);
		*/
	}
	
	/**
	* Returns a <img> tag with the image file defined by $file and processed according to the properties in the TypoScript array.
	* Mostly this function is a sub-function to the IMAGE function which renders the IMAGE cObject in TypoScript. This function is called by "$this->cImage($conf['file'],$conf);" from IMAGE().
	*
    * @param		string		File TypoScript resource
    * @param		array		TypoScript configuration properties for the IMAGE object
    * @return		string		<img> tag, (possibly wrapped in links and other HTML) if any image found.
    * @access private
    * @see IMAGE()
    */
	function cImage($file,$conf) {           
		$info = $this->getImgResource($file,$conf['file.']);
		$GLOBALS['TSFE']->lastImageInfo=$info;
		if (is_array($info))	{
			$info[3] = t3lib_div::png_to_gif_by_imagemagick($info[3]);
			$GLOBALS['TSFE']->imagesOnPage[]=$info[3];		// This array is used to collect the image-refs on the page...

			if (!strlen($conf['altText']) && !is_array($conf['altText.']))	{	// Backwards compatible:
				$conf['altText'] = $conf['alttext'];
				$conf['altText.'] = $conf['alttext.'];
			}
        	$altParam = $this->getAltParam($conf);
			###################################
			## Here begins RealUrl_image ######
			###################################
			// initialice class variables
			$this->fl_realurl_image_init($conf);
			// get the original file path
			$org_file_path = htmlspecialchars(trim(t3lib_div::rawUrlEncodeFP($info[3])));
			// generate the file path
			if ($conf['imageLinkName.']['enable']) {
			    $file_name = $this->fl_realurl_image_generateFilePath($org_file_path,$info,$conf);
			}
			else {
			    $file_name = $org_file_path;
			}
            // generate the <img>-tag
            $theValue = '<img src="'
						.htmlspecialchars($GLOBALS['TSFE']->absRefPrefix).$file_name.'"'
			            .' width="'.$info[0].'" height="'.$info[1].'"'
						.$this->getBorderAttr(' border="'.intval($conf['border']).'"')
						.($conf['params']?' '.$conf['params']:'').($altParam)
						.' />';
			##################################
        	### Here ends RealURL_Image ######
        	##################################
        	/*
			$theValue = '<img src="'.htmlspecialchars($GLOBALS['TSFE']->absRefPrefix.t3lib_div::rawUrlEncodeFP($info[3])).'" width="'.$info[0].'" height="'.$info[1].'"'.$this->getBorderAttr(' border="'.intval($conf['border']).'"').(($conf['params'] || is_array($conf['params.']))?' '.$this->stdwrap($conf['params'],$conf['params.']):'').($altParam).' />';
			*/
			if ($conf['linkWrap'])	{
				$theValue = $this->linkWrap($theValue,$conf['linkWrap']);
			} elseif ($conf['imageLinkWrap']) {
				$theValue = $this->imageLinkWrap($theValue,$info['origFile'],$conf['imageLinkWrap.']);
			}
			return $this->wrap($theValue,$conf['wrap']);
		}
	}
	
	###########################################################################################################
	## functions for fl_realimage_url #########################################################################
	###########################################################################################################

	/*
     * initalise: get the configuration for fl_realurl_image
     * $conf['imageLinkName'] in the IMAGE config array is what we need.
     *
     * @param       &array    config of the IMAGE object
     * @return 		nothing
     */
	function fl_realurl_image_init(&$conf) {
		// merging global $GLOBALS['TSFE']->tmpl->setup['config.']['fl_realurl_image.'] with local $conf (local overwrites)
		if (!$conf['imageLinkName.']) {
		    $conf['imageLinkName.'] = array();
		}
		$conf['imageLinkName.'] = t3lib_div::array_merge_recursive_overrule($GLOBALS['TSFE']->tmpl->setup['config.']['fl_realurl_image.']['imageLinkName.'],$conf['imageLinkName.'],0,0);
		# the global conf of the extension
		$this->fl_conf = $GLOBALS['fl_realurl_image'];
	}
	
	/*
     * generates the file path to the new image
     *
     * @param       string    	path to the original image
     * @param       array       info array to the original image
     * @param       array       config array of the IMAGE object
     * @return 		string      path to the new image
     */
	function fl_realurl_image_generateFilePath($imgPathOrg,$info,$conf) {
		# generate something that is suitable as a basis for generating a speaking file name
        if ($conf['imageLinkName.']['data'] && !$conf['imageLinkName']) {
			// damInfo
			if ($info['origFile'] && t3lib_extMgm::isLoaded('dam')) {
				// get information for item from tx_dam
				$items =  $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
					'*',
					'tx_dam',
					'(file_name = "'.basename($info['origFile']).'" AND file_path = "'.t3lib_div::dirname($info['origFile']).'/") '
					.$this->enableFields('tx_dam')   							// $this->cObj = $this as we XCLASS cObj
					.' AND sys_language_uid=0'
    			);
    			// get language overlay
    			if ($GLOBALS['TSFE']->sys_language_content) {
					$OLmode = ($GLOBALS['TSFE']->sys_language_mode == 'strict'?'hideNonTranslated':'');
					$items[0] = $GLOBALS['TSFE']->sys_page->getRecordOverlay('tx_dam', $items[0], $GLOBALS['TSFE']->sys_language_content, $OLmode);
				}
				$damInfo = $items[0];
			}
			// pageInfo
			global $TSFE;
			$rootLineDepth = sizeof($TSFE->tmpl->rootLine);
			$pageInfo = $TSFE->tmpl->rootLine[$rootLineDepth-1];
			// walk the options until a possible base for a file-name is found
			$parts = explode ("//",$conf['imageLinkName.']['data']);
			for ($i=0; $i < sizeof($parts) && !$conf['imageLinkName']; $i++) {
				list($source,$item) = explode(":",$parts[$i]);
				$source = trim($source);
				$item = trim($item);
				if ($source == "dam" && $damInfo[$item]) {
                    $conf['imageLinkName'] = $damInfo[$item];
				}
				elseif ($source == "ts" && ($conf[$item] || $conf[$item.'.'])) {
				    $conf['imageLinkName'] = $this->stdWrap($conf[$item],$conf[$item.'.']);
				}
				elseif ($source == "file" && $info[$item]) {
				    $conf['imageLinkName'] = $info[$item];
				}
				elseif ($source == "page" && $pageInfo[$item]) {
				    $conf['imageLinkName'] = $pageInfo[$item];
				}
				elseif ($source != "page" && $source != "dam" && $source != "file" && $source != "ts") {
				    $conf['imageLinkName'] = $parts[$i];
				}
			}
			// if $conf['imageLinkName'] is a filename then get only the name itself with no path or ending
			if (strstr($conf['imageLinkName'],"/") && strstr($conf['imageLinkName'],".")) {
	       		$conf['imageLinkName'] = basename($conf['imageLinkName']);
			}
			$conf['imageLinkName'] = str_replace(array (".jpg",".JPG",".jpeg",".JPEG",".png",".PNG",".gif",".GIF"),'',$conf['imageLinkName']);
			$conf['imageLinkName'] = urldecode($conf['imageLinkName']);
			// unset $conf['imageLinkName.']['data'], cause it fulfilled it's duty
			unset($conf['imageLinkName.']['data']);
		}
		// stdWrap for $conf['imageLinkName']
		$conf['imageLinkName'] = $this->stdWrap($conf['imageLinkName'],$conf['imageLinkName.']);
		// encoding can be done by stdWrap / userFunc, or the smartEncode can be used
		if ($conf['imageLinkName.']['smartEncode']) {
			$conf['imageLinkName'] = $this->fl_realurl_image_smartEncode($conf['imageLinkName'],$conf['imageLinkName.']['smartEncode.']);
   		}
        // the path to the real image location
        $imgPathOrg = htmlspecialchars(trim(t3lib_div::rawUrlEncodeFP($info[3]))); // true path to image: typo3temp/pics/2305e38d9c.jpg
   		// collision handling can also be done by stdWrap / userFunc, or this function can be used
   		if ($conf['imageLinkName.']['fileNameGeneration']) {
   		    $conf['imageLinkName'] = $this->fl_realurl_image_fileNameGeneration($imgPathOrg,$conf['imageLinkName'],$conf['imageLinkName.']['fileNameGeneration.']);
   		}
   		// exlude a part of the file_name ... be aware, that only through setting .htaccess correctly the images will be acessable
   		if ($this->fl_conf['virtualPathRemove']) {
   		    $conf['imageLinkName'] = str_replace($this->fl_conf['virtualPathRemove'],'',$conf['imageLinkName']);
   		}
   		// return finished linkName
   		return $conf['imageLinkName'];
   	}
   			
	/**
     * Convert a title to something that can be used in an page path:
     * - Convert spaces to underscores
     * - Convert non A-Z characters to ASCII equivalents
     * - Convert some special things like the 'ae'-character
     * - Strip off all other symbols
     * - pass through rawurlencode()
     * Works with the character set defined as "forceCharset"
     *
     * @param       string		a text string to encode into a nice url
     * @param       array       config of $conf['imageLinkName.']['smartEncode.']
     * @return      string      Encoded title
     * @see rootLineToPath()
     */
	function fl_realurl_image_smartEncode($title,$conf) {
    	// Fetch character set:
        $charset = $GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset'] ? $GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset'] : $GLOBALS['TSFE']->defaultCharSet;
        // Convert some special tokens to the space character:
		if (!$conf['spaceCharacter']) {
		    $conf['spaceCharacter'] = "-";
		}
       	$title = strtr($title,' -+_',$conf['spaceCharacter'].$conf['spaceCharacter'].$conf['spaceCharacter']);
		// Convert extended letters to ascii equivalents:
		$title = $GLOBALS['TSFE']->csConvObj->specCharsToASCII($charset,$title);
		// Strip the rest...: replace other characters with $space
		$title = preg_replace('/[^a-z0-9\/\\\]/i', $conf['spaceCharacter'], $title);
 		// Convert multiple 'spaces' to a single one
		$title = preg_replace('/[\/\\' . $conf['spaceCharacter'] . ']+' . '/i', $conf['spaceCharacter'], $title);
        $title = trim($title,$conf['spaceCharacter']);
		// Return encoded URL:
        $title = rawurlencode($title);
        // return
        return $title;
	}
	    
    /**
     * Generate the new image path
     *
     * @param 		string 		the path to the original image e.g.: typo3temp/pics/2305e38d9c.jpg
     * @param		string		the possible file name (with no ending) of the new path
     * @param		array		$conf['imageLinkName.']['fileNameGeneration.']
     * @return 		string 		a finished path to the new image
     */
	function fl_realurl_image_fileNameGeneration ($org_path,$new_base,$conf) {
        list($org_base,$org_end) = explode('.',basename($org_path));
        $org_end = '.'.$org_end;
        # the image Folder
        if ($conf['imageFolder']) {
            $new_folder = $conf['imageFolder'].'/';
		}
		# add a short hash to any image
		if ($conf['hashLength']) {
        	if ($conf['hashLength'] > strlen($org_base)) {
				$conf['hashLength'] = strlen($org_base);
			}
			$new_apex = '-'.substr($org_base, 0, $conf['hashLength']);
		}
		# collisionHandling
		$count = ''; // Initialize with empty string to avoid !$count problem
		while (1) {
            $new_path = $new_folder.$new_base.$new_apex.$count.$org_end;
			if ($this->fl_realurl_image_writeDB($org_path,$new_path)) {
				// create fileLink in case this link got lost or never existed
				if (!is_file($new_path) && !is_link($new_path) && $this->fl_conf['fileLinks']){
					$this->fl_realimage_url_createFileLink_cObj($org_path,$new_path);
				}
				break;
			}
		    else {
				// go count one up to avoid collision
				if ($count === '') { // Set count to 0 when run once
		            $count = 0;
		            if (!$new_apex) {
		                $new_apex = '-';
					}
				}
				else {
					$count++;
				}
			}
		}
		// return the generated path to the new image
		return $new_path;
	}

    /**
     * checks if a possible new image location is already taken by another original image
     * - in case not writes a pair of original path and new path to an image in the db
     * - in case the same image already exists, updates the DB entry
     * - in case another image owns this requested new file name, it returns false
     *
     * @param 		string 		the path to the original image e.g.: typo3temp/pics/2305e38d9c.jpg
     * @param		string      the possible path to the new image
     * @return      boolean		true = DB-Entry successful; false = DB entry not done as new name already occupied
     */
	function fl_realurl_image_writeDB($org_path,$new_path) {
		$res_realurl = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,image_path,page_id','tx_flrealurlimage_cache','realurl_path=\''.$new_path.'\'');
        $num_realurl = $GLOBALS['TYPO3_DB']->sql_num_rows($res_realurl);
        $data_realurl = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_realurl);
        // the requested path is free up to now
        if ($num_realurl == 0){
			// insert in DB
			$insertArray = array(
	        	'crdate' => time(),         			// image link first created at
	        	'pid' => intval($conf['storagePid']), 	// pid of the storage folder where the Typo3 list modul will find the DB enties
	            'tstamp' => time(),         			// image link last requestet on
	            'image_path' => $org_path,  			// path to the original image
	            'realurl_path' => $new_path,    		// path to the new image (link)
	            'page_id' => $GLOBALS['TSFE']->id   	// comma seperated list of pid's where the image has been requested from
	        );
	        $res_realurl = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_flrealurlimage_cache', $insertArray);
            return true;
		}
		// requested path already taken by this picture
		elseif ($num_realurl == 1 && $data_realurl['image_path'] == $org_path) {
		    $pids = explode(',',$data_realurl['page_id']);
			if (!in_array($GLOBALS['TSFE']->id, $pids)) {
		    	$page_id = $data_realurl['page_id'].','.$GLOBALS['TSFE']->id;
			}
			else {
			    $page_id = $data_realurl['page_id'];
			}
			// insert in DB
			$insertArray = array(
	            'tstamp' => time(),         	// image link last requestet on
	            'page_id' => $page_id			// comma seperated list of pid's where the image has been requested from
	        );
	        $res_realurl = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_flrealurlimage_cache','realurl_path=\''.$new_path.'\'', $insertArray);
		    return true;
		}
		// requested path already reserved for another picture
		else {
			return false;
		}
	}
	
    /**
     * creates a hard-link / sym-link / copy of the oritinal image to the new location
     *
     * @param 		string 		the path to the original image e.g.: typo3temp/pics/2305e38d9c.jpg
     * @param		string      the path to the new image
     * @return 		nothing
     */
	function fl_realimage_url_createFileLink_cObj($org_path,$new_path) {
        // create folder if required
        $new_folder = t3lib_div::dirname($new_path);
		if (!is_dir($new_folder)) {
			mkdir ($new_folder);
		}
		if (TYPO3_OS == 'WIN') {
			if (is_file($new_path)) {
				return;
			}
			// no copy
			if ($this->fl_conf['fileLinks'] == "none") {
				return;
			}
		    // true copy
			elseif ($this->fl_conf['fileLinks'] == "copy") {
				copy($org_path,$new_path);
			}
        	// symlink
        	# ... not possible in WIN => = hard-link
		    // hard-link
			else {
				exec('fsutil hardlink create "'.$new_path.'" "'.$org_path.'"');
			}
		}
        else {
			if (is_file(PATH_site . $new_path)) {
				return;
			}
			// no copy
			if ($this->fl_conf['fileLinks'] == "none") {
				return;
			}
			// true copy
			elseif ($this->fl_conf['fileLinks'] == "copy") {
				copy(PATH_site . $org_path, PATH_site . $new_path);
			}
        	// symlink
			elseif ($this->fl_conf['fileLinks'] == "symLink") {
				symlink(PATH_site . $org_path, PATH_site . $new_path); // Secure for open_basedir restriction
			}
            // hard-link
			else {
				link($org_path, PATH_site . $new_path);
			}
		}
	}
}
?>